/*
Copyright 2008 - Gino Passarelli

Rewritten piece by piece by Kestas Kuliukas 2009&2010
http://kestas.kuliukas.com/AmnetGadget/
*/

// Run once on first load; set up to refresh periodically, start the first refresh
function loadMain() {
	new PeriodicalExecuter(requestPlanRawXML, settings.refreshMinutes*60);
	requestPlanRawXML();
}

// Update the gadget; Requests XML from Amnet, creates parser, calls renderer on the new parser
function requestPlanRawXML()
{
	var XMLHttp = new ActiveXObject("Microsoft.XMLHTTP");
	
	XMLHttp.Open("GET", "https://memberutils.amnet.com.au/usage.asmx/GetCurrentPeakUsage?username="+ settings.username + "&password=" + settings.password, false);
	
	XMLHttp.onreadystatechange = function() {
		if (XMLHttp.readyState != 4 || XMLHttp.status != 200)
			return false;
		
		var p = new plan(XMLHttp.responseXML);
		
		renderPlanData(p);
	};
	
	XMLHttp.setRequestHeader('Content-Type', 'text/xml');
	XMLHttp.send();
}

// Returns a string of the current time, used to display the time last updated (i.e. the time when this was run)
function lastUpdated() {
	var d = new Date();
	var hours = d.getHours();
	var mins = d.getMinutes();
	var am = (hours<12?'AM':'PM');
	if( hours==0 ) hours = 12;
	else if(hours > 12) hours -= 12;
	
	return hours+':'+(mins<10?'0'+mins:mins)+' '+am;
}

// Using the plan renderer create and output the HTML
function renderPlanData(plan)
{
	buf = '<div>';
	
	buf=buf+'<div class="plan">'+plan.name+'</div>';
	
	buf=buf+plan.period.HTML.show();
	
	buf=buf+'<div class="lighten">';
	buf=buf+'<div class="planType">Global quota limits</div>';
	
	buf = buf+plan.bw.global.peak.HTML.show();
	buf = buf+plan.bw.global.offpeak.HTML.show();
	
	buf=buf+'<div class="planType">Local (WAIX) quota limits</div>';
		
	buf = buf+plan.bw.local.peak.HTML.show();
	buf = buf+plan.bw.local.offpeak.HTML.show();
	
	buf =buf+'</div>';
	
	buf=buf+'<div class="planType"><a href=\"#\" onclick=\"requestPlanRawXML();return false;\">Last updated: '+lastUpdated()+'</a></div>';
	
	$("gadgetMainFrame").update('<div>'+buf+'</div>');
	
	plan.applyPeak();
}
